<?php
App::uses('EvCustomFieldsAppModel', 'EvCustomFields.Model');
/**
 * EvCustomFields.FieldData Model
 *
 */
class CustomFieldData extends EvCustomFieldsAppModel {

	public $useTable = false;

	/**
	 * format any custom field data brought in via a contain (rather then the bahviour)
	 *
	 * @param 	array 	$item 			The array of data
	 * @return 	array 	$formattedItem 	The formatted data
	 */
	public function formatCfArray($item) {
		return $this->findCustomFields($item);
	}

	/**
	 * find the customFields array within the item
	 *
	 * @param 	array 	$item 			The child array of data to search in
	 * @return 	array 	$formattedItem 	The formatted data
	 */
	public function findCustomFields($item) {
		foreach ($item as $key => $value) {

			if ($key === 'CustomFields') {
				$item[$key] = $this->formatArray($value);
			} elseif (is_array($value)) {
				$item[$key] = $this->findCustomFields($value);
			}
		}

		return $item;
	}

	/**
	 * format the actual custom fields data
	 *
	 * @param 	array 	$item 			the Custom Field array to format
	 * @return 	array 	$formattedItem  The formatted array
	 */
	public function formatArray($data) {
		return Hash::combine(
			$data,
			'{n}.Field.name',
			'{n}.value'
		);
	}
}
